{"openapi":"3.0.0","info":{"description":"API reference for the 10xit NFT engine.\n## Use\n### Mint NFTs\n1. `POST /create-wallet`: Generates a walletId for your user.\n\n2. `POST /create-nft/{walletId}` or `POST /create-3d-nft/{walletId}`: Mint an NFT.\n### Get NFTs\n- `GET /get-all-nfts`: Get all NFTs.\n\n- `GET /get-user-nfts/{walletId}:`: Get all NFTs minted with specific walletId.\n\n- `GET /get-nft/{id}:`: Get specific NFT with nftId.\n\n### Other\n- `GET /get-wallet/{walletId}:`: Get wallet information associated with walletId (private key, address).\n\n## Authentication\nAll requests are required to have an `X-API-KEY` header.    \n","version":"1.0.0","title":"10xit API"},"tags":[{"name":"wallets"},{"name":"nfts"}],"paths":{"/create-nft/{walletId}":{"post":{"tags":["nfts"],"summary":"Mint an NFT","description":"This request is used to mint an NFT. It will take a few seconds to execute.","parameters":[{"name":"walletId","in":"path","description":"walletId of user minting nft.","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"## Parameters\n  - `content`: File data (png, jpg, obj, etc) in base64 format.\n  \n  - `filename`: File name with extension (e.g. example.png).\n  \n  - `metadata`: NFT properties.\n  \n    - `name`: **required**. NFT name.\n    \n    - `description`: **required**. NFT description.\n    \n    - `attributes`: **optional**. The NFT attributes can be used to give NFT items extra properties on OpenSea. (e.g. `{ trait_type: \"Level\", value: 5 }` value can be a number or a string).\n","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NFTRequest"}}}},"responses":{"200":{"description":"## Returns\n  - `nftId`: Id associated with the NFT (save this so that you can query for its data later on).\n  \n  - `mintedBy`: walletId of user who minted the NFT.\n  \n  - `openseaUrl`: url to find the NFT on the OpenSea marketplace. It can take up to a day for OpenSea to recognize the NFTs existence on the blockchain (but it usually takes a few minutes).\n  \n  - `walletAddress`: The address of the wallet associated with the walletId on the blockchain.\n","content":{"application/json":{"schema":{"type":"object","properties":{"nft":{"$ref":"#/components/schemas/NFTResponse"}}}}}},"403":{"description":"No `X-API-KEY` header provided or incorrect api key.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"500":{"description":"An internal server error has occured, please contact support."}},"security":[{"api_key":[]}]}},"/create-3d-nft/{walletId}":{"post":{"tags":["nfts"],"summary":"Mint a 3D NFT.","description":"This request is used to mint an NFT. Unlike `/create-nft` this request consumes multipart form data. \nYou'll need to send: \n- **objectFile**: Your 3D object with filetype of .obj (contentType: file).\n- **base64Img**: A png image in base64 to act as a preview of your object on OpenSea (contentType: string).\n","parameters":[{"name":"walletId","in":"path","description":"walletId of user minting nft.","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"## Parameters\n  - `base64Img`: **text** - PNG image preview of your 3D object in base64.\n  \n  - `objectFile`: **file** - Your 3D object file.\n  \n  - `metadata`: **text** - NFT properties.\n  \n    - `name`: **required**. NFT name.\n    \n    - `description`: **required**. NFT description.\n    \n    - `attributes`: **optional**. The NFT attributes can be used to give NFT items extra properties on OpenSea. (e.g. `{ trait_type: \"Level\", value: 5 }` value can be a number or a string).\n","required":true,"content":{"multipart/form-data":{"schema":{"$ref":"#/components/schemas/3DNFTRequest"}}}},"responses":{"200":{"description":"## Returns\n  - `nftId`: Id associated with the NFT (save this so that you can query for its data later on).\n  \n  - `mintedBy`: walletId of user who minted the NFT.\n  \n  - `openseaUrl`: url to find the NFT on the OpenSea marketplace. It can take up to a day for OpenSea to recognize the NFTs existence on the blockchain (but it usually takes a few minutes).\n  \n  - `walletAddress`: The address of the wallet associated with the walletId on the blockchain.\n","content":{"application/json":{"schema":{"type":"object","properties":{"nft":{"$ref":"#/components/schemas/NFTResponse"}}}}}},"400":{"description":"### Returns several different error messages.\n#### Notable\n  - **Object file not found**: 3D object file is missing from request.\n  \n  - **File with contentType image/png not found**: png image preview of the 3D object is missing from the request.\n  \n  - **To mint a 3d object you must send 2 files: the object file and an image file**: One of the required files is missing from the request.\n","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"403":{"description":"No `X-API-KEY` header provided or incorrect api key.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"500":{"description":"An internal server error has occured, please contact support."}},"security":[{"api_key":[]}]}},"/create-wallet":{"post":{"tags":["wallets"],"summary":"Generate walletId for a user","description":"Use this request to generate a walletId for a user. This walletId will be used to create NFTs.","responses":{"200":{"description":"## Returns\n- `walletId`: An id associated with the blockchain wallet we've generated for your user.\n","content":{"application/json":{"schema":{"type":"object","properties":{"walletId":{"type":"string"}}}}}},"403":{"description":"No `X-API-KEY` header provided or incorrect api key.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"500":{"description":"An internal server error has occured, please contact support."}},"security":[{"api_key":[]}]}},"/get-all-nfts":{"get":{"tags":["nfts"],"description":"Returns an array of all NFTs.","summary":"Get all NFTs minted","responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"type":"object","properties":{"NFTs":{"items":{"$ref":"#/components/schemas/NFTResponse"}}}}}}},"403":{"description":"No `X-API-KEY` header provided or incorrect api key.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"500":{"description":"An internal server error has occured, please contact support."}},"security":[{"api_key":[]}]}},"/get-nft/{id}":{"get":{"tags":["nfts"],"description":"Get specific NFT data using an nftId.","summary":"Fetch an NFT","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"type":"object","properties":{"nft":{"$ref":"#/components/schemas/NFTResponse"}}}}}},"403":{"description":"No `X-API-KEY` header provided or incorrect api key.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"500":{"description":"An internal server error has occured, please contact support."}},"security":[{"api_key":[]}]}},"/get-user-nfts/{walletId}":{"get":{"tags":["nfts"],"description":"Fetch all NFTs for a wallet using walletId. Returns an array of NFTs.","summary":"Get all NFTs minted by user with walletId.","parameters":[{"name":"walletId","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"type":"object","properties":{"NFTs":{"items":{"$ref":"#/components/schemas/NFTResponse"}}}}}}},"403":{"description":"No `X-API-KEY` header provided or incorrect api key.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"500":{"description":"An internal server error has occured, please contact support."}},"security":[{"api_key":[]}]}},"/get-wallet/{walletId}":{"get":{"tags":["wallets"],"summary":"Get blockchain wallet information.","description":"Retrieve blockchain wallet address and private key associated with walletId. This is useful if your user wants to access their blockchain wallet holding their NFTs (this will also be required if they want to list their item for sale on OpenSea).","parameters":[{"name":"walletId","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/WalletDetailsResponse"}}}},"403":{"description":"No `X-API-KEY` header provided or incorrect api key.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"500":{"description":"An internal server error has occured, please contact support."}},"security":[{"api_key":[]}]}}},"servers":[{"url":"https://api.10xit.io/prod"},{"url":"https://api.10xit.io/test"}],"components":{"securitySchemes":{"api_key":{"type":"apiKey","name":"x-api-key","in":"header"}},"schemas":{"WalletDetailsResponse":{"type":"object","properties":{"walletId":{"type":"string"},"decryptedPrivateKey":{"type":"string"},"address":{"type":"string"}}},"NFTResponse":{"type":"object","properties":{"nftId":{"type":"string"},"mintedBy":{"type":"string"},"walletAddress":{"type":"string"},"openseaUrl":{"type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataResponse"},"createdAt":{"type":"string"}}},"NFTRequest":{"type":"object","required":["metadata","filename","content"],"properties":{"metadata":{"$ref":"#/components/schemas/MetadataRequest"},"filename":{"type":"string"},"content":{"type":"string"}}},"3DNFTRequest":{"type":"object","required":["metadata","base64Img","objectFile"],"properties":{"metadata":{"$ref":"#/components/schemas/MetadataRequest"},"base64Img":{"type":"string"},"objectFile":{"type":"string","format":"binary"}}},"MetadataResponse":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"image":{"type":"string"},"attributes":{"$ref":"#/components/schemas/MetadataAttributes"}}},"MetadataRequest":{"type":"object","required":["name","description"],"properties":{"name":{"type":"string"},"description":{"type":"string"},"attributes":{"$ref":"#/components/schemas/MetadataAttributes"}}},"MetadataAttributes":{"type":"array","items":{"type":"object","required":["value","trait_type"],"properties":{"value":{"oneOf":[{"type":"string"},{"type":"integer"}]},"trait_type":{"type":"string"}}}}}}}